#include "combinator.hh"
#include "operator.hh"

//#include <stdio.h>

void Combinator::calculateherz()
{
    register unsigned freqnum = freqlo + (freqhi*256);
    hz = freqnum * 49716 / (1 << (20 - octave));
    
    /*
        freqnum = hz * 2^(20 - octave) / 49716 Hz
        
    So, 
    
        hz = freqnum * 49716 Hz / 2^(20 - octave)
    
    */
    
    /*
    printf("%p Freqnum %X:%02X, octave %u, %u Hz\n",
           (void*)this,
           freqhi,freqlo, octave, hz);
    */
}

void Combinator::WriteA0(unsigned char value)
{
    freqlo = value;
    calculateherz();
}

void Combinator::WriteB0(unsigned char value)
{
    freqhi = value & 3;
    octave = (value >> 2) & 7;
    
    if(value & 0x20)
    {
    	op->KeyOn();
   		angle = 0.0;
    	if(!enabled)
    	{
    		enabled = true;
    	}
    }
    else
    {
    	if(enabled)
    	{
	    	op->KeyOff();
	    	enabled = false;
	    }
    }
    calculateherz();
}

void Combinator::WriteC0(unsigned char value)
{
    additive     = value & 1;
    feedbacktype = (value >> 1) & 7;
    left  = value & 0x10;
    right = value & 0x20;
}

void Combinator::WriteE0(unsigned char value)
{
    waveform = value & 7;
}

static const double PII = 3.141592653589793;

double Combinator::Produce(double secs)
{
    op->Run(secs);
    register double value = 0.0;
    value += op->Produce(waveform, hz, angle);
    angle += PII*2 * secs;
    return value;
}

/*
2001-09/08 03:17 EEST <Malfunction>

E(t)=A(t)*sin[(Nc+Dc)*wt+B(t)*sin(Nm+Dm)*wt]
A(t) : Volume envelope
B(t) : Timbre envelope
Nx : 1/2 of basic pitch or multiple value
Dx : 1/2 of basic pitch harmonic value
*/
