#ifndef opl3emu_operator_hh
#define opl3emu_operator_hh

class Operator
{
	bool tremolo;
	bool vibrato;
	bool dosustain;
	bool KSR;                  // Decrease note lengths when freq grows?
	unsigned char freqmul;
	unsigned char KSL;         // 0..3 - Attenuation = {0,1.5,3,6}[octave]
	unsigned char attack;      // 0..15- Rising time.
	unsigned char decay;       // 0..15- 
	unsigned char sustain;     // 0..15-
	unsigned char release;     // 0..15- Rate at disappear after key-off.
	
	double effvol, outputlevel;
	
	class timer *envelopetimer;
	unsigned envpos1, envpos2;
	
	
	Operator *target, *source;
	enum { mod_freq, mod_add } chaintype;
	
public:
	Operator();
	~Operator();
	
	double multiplyfreq(double freq) const;
	
	void Write20(unsigned char value);
	void Write40(unsigned char value);
	void Write60(unsigned char value);
	void Write80(unsigned char value);
	
	void Modulate(Operator &o);
	void AddTo(Operator &o);
	void Unlink(void);
	
	void Run(double secs);
	
	double Produce(unsigned waveno, double freq, double angle, double shift=0.0);
	
	bool IsProductive() const { return !source; }

	void KeyOn();
	void KeyOff();	
};

extern unsigned OperatorPortOffset(unsigned channel);
extern unsigned PortOffsetOperator(unsigned offset);

#endif
