#ifndef opl3emu_timers_hh
#define opl3emu_timers_hh

class timer
{
	bool active;
	double timefraction;
public:
	unsigned char value;
	bool hit, irqs;
	
	timer() : timefraction(0) { }
	
	void Reset() { timefraction=0; value=0; hit=false; }

    unsigned Advance(double length, double add);
    void Run(double seconds, double length);
    void Activate();
    void Deactivate();
    void Set(unsigned char nv);
};

class Timers
{
private:	
	timer timer1, timer2;
	
public:
	void Run(double seconds);
	
	const unsigned char ReadStatus() const;
	void WriteTimer1(unsigned char value);
	void WriteTimer2(unsigned char value);
	void WriteReg4(unsigned char value);
};

#endif
